#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001-2003, Guardian Digital Inc.
 | $Id: do_edit_config.cgi,v 1.6 2003/02/25 19:48:05 rwm Exp $
 |
 | Ryan W. Maple <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines and populate %in.
  require "firewall-lib.pl";
  &ReadParse();


  ###  Perform basic input validation.
  if (! $in{'single_iface'}) {
    if ($in{'TRUSTED_IF'} eq "NULL") {
      &firewallPrintError("Please select a 'Trusted Interface'."); exit;
    }
    elsif ($in{'UNTRUSTED_IF'} eq "NULL") {
      &firewallPrintError("Please select an 'Untrusted Interface'."); exit;
    }
    elsif ($in{'LOAD_MODULES'} eq "NULL") {
      &firewallPrintError("Please select a value for 'Load Modules at Boot'."); exit;
    }
    elsif ($in{'TRUSTED_IF'} eq $in{'UNTRUSTED_IF'}) {
      &firewallPrintError("You cannot make the same interface both 'Trusted' and 'Untrusted'."); exit;
    }
  }


  ###
  ###  Define local variables.
  ###
  my ($lref);
  my ($TRUSTED_IF, $UNTRUSTED_IF);
  my ($TRUSTED_IP, $UNTRUSTED_IP);
  my ($TRUSTED_NET, $UNTRUSTED_NET);
  my ($LOAD_MODULES);

  ###
  ###  Save the trusted/untrusted interface information.
  ###
  $TRUSTED_IF    =  $in{'TRUSTED_IF'};
  $UNTRUSTED_IF  =  $in{'UNTRUSTED_IF'};
  $LOAD_MODULES  =  $in{'LOAD_MODULES'};
  $lref          =  &read_file_lines($CONFIGURATION_FILE);

  ###  Get our (un)trusted IPs.
  $TRUSTED_IP = $UNTRUSTED_IP = "";
  foreach my $i (&firewallGetInterfaces()) {
    if ($i->{'iface'} eq $TRUSTED_IF)      {
      $TRUSTED_IP     = $i->{'address'};

      $TRUSTED_NET    = &firewallGetNetworkNumber($i->{'address'}, $i->{'netmask'});
      $TRUSTED_NET   .= "/$i->{'cidr'}";
    }
    elsif ($i->{'iface'} eq $UNTRUSTED_IF) {
      $UNTRUSTED_IP   = $i->{'address'};

      $UNTRUSTED_NET  = &firewallGetNetworkNumber($i->{'address'}, $i->{'netmask'});
      $UNTRUSTED_NET .= "/$i->{'cidr'}";
    }
  }

  ###  Zero-out the "trusted" stuff if we only have one interface.
  if ($in{'single_iface'}) {
    $TRUSTED_IF = ""; $TRUSTED_IP = ""; $TRUSTED_NET = ""; $LOAD_MODULES = "";
  }

  ###  Update the file.
  for (my $i = 0; $i < @$lref; $i++)
  {
    if (@$lref[$i] =~ m/^TRUSTED_IF=.*$/) {
      @$lref[$i] = "TRUSTED_IF=$TRUSTED_IF";
    }
    elsif (@$lref[$i] =~ m/^UNTRUSTED_IF=.*$/) {
      @$lref[$i] = "UNTRUSTED_IF=$UNTRUSTED_IF";
    }

    elsif (@$lref[$i] =~ m/^TRUSTED_IP=.*$/) {
      @$lref[$i] = "TRUSTED_IP=$TRUSTED_IP";
    }
    elsif (@$lref[$i] =~ m/^UNTRUSTED_IP=.*$/) {
      @$lref[$i] = "UNTRUSTED_IP=$UNTRUSTED_IP";
    }

    elsif (@$lref[$i] =~ m/^TRUSTED_NET=.*$/) {
      @$lref[$i] = "TRUSTED_NET=$TRUSTED_NET";
    }
    elsif (@$lref[$i] =~ m/^UNTRUSTED_NET=.*$/) {
      @$lref[$i] = "UNTRUSTED_NET=$UNTRUSTED_NET";
    }

    elsif (@$lref[$i] =~ m/^LOAD_MODULES=.*$/) {
      @$lref[$i] = "LOAD_MODULES=$LOAD_MODULES";
    }
  }

  ###  Re-write the file.
  &flush_file_lines();


  ###  Go back to the firewall index page.
  &redirect("index.cgi");
