#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001-2003, Guardian Digital Inc.
 | $Id: do_edit_portfw.cgi,v 1.6.2.2 2003/04/18 12:37:08 rwm Exp $
 |
 | Ryan W. Maple <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines and populate %in.
  require "firewall-lib.pl";
  &ReadParse();


  ###  Input Validation (only if we are creating/modifying).
  if ($in{'create'} || $in{'save'})
  {
    if (! $in{'proto'}) {
      &firewallPrintError("Please select a 'Protocol'."); exit;
    }
    elsif ($in{'port'} eq "undef") {
      &firewallPrintError("Please select a 'Port'."); exit;
    }
    elsif ($in{'laddr'} eq "undef") {
      &firewallPrintError("Please select a 'Local Address'."); exit;
    }
    elsif (! $in{'raddr'}) {
      &firewallPrintError("Please select a 'Remote Address'."); exit;
    }
##    if ($in{'raddr'} !~ /^[^:; \t]+$/) {
    if (! &isIP($in{'raddr'})) {
      &PrintError("'$in{'raddr'}' is not a valid IP address.");
      exit;
    }
  }


  ###  We want to define a new rule, so simply append it.
  if ($in{'create'}) {
    my ($new, $lref);

    my $cnt = 0;
    foreach my $p (&firewallListPortfw()) { $cnt++; }
    if ($cnt >= 10) {
      my $msg = "You have reached the limit of 10 port forwarding rules\\n"
              . "available in the Community Edition of EnGarde Secure Linux.";
      &PrintError($msg);
      exit;
    }

    $new  = "\$IPTABLES -t filter -A FORWARD -p TCP -i \$UNTRUSTED_IF ";
    $new .= "-s 0/0 -d $in{'raddr'} --dport $in{'port'} -j ACCEPT\n";
    $new .= "\$IPTABLES -A PREROUTING -t nat -p " . uc($in{'proto'}) . " ";
    $new .= "-d $in{'laddr'} --dport $in{'port'} -j DNAT ";
    $new .= "--to-destination $in{'raddr'}:$in{'port'}";

    $lref = &read_file_lines($PORTFW_FILE);
      push @$lref, $new;
    &flush_file_lines();

    ###  Re-read the portfwd config now.
    &firewallPortFwCtl('restart');
  }

  ###  We want to delete or modify a rule.
  elsif ($in{'delete'} || $in{'save'}) {
    my (@P, $lref);

    ###  Read the file.
    $lref = &read_file_lines($PORTFW_FILE);

    ###  Splice is the best perl function ever, I swear.
    if ($in{'delete'}) { splice @$lref, ($in{'lineno'} - 1), 2; }
    else {
      my ($new);

      $new  = "\$IPTABLES -t filter -A FORWARD -p TCP -i \$UNTRUSTED_IF ";
      $new .= "-s 0/0 -d $in{'raddr'} --dport $in{'port'} -j ACCEPT\n";
      $new .= "\$IPTABLES -A PREROUTING -t nat -p " . uc($in{'proto'}) . " ";
      $new .= "-d $in{'laddr'} --dport $in{'port'} -j DNAT ";
      $new .= "--to-destination $in{'raddr'}:$in{'port'}";

      splice @$lref, ($in{'lineno'} - 1), 2, $new;
    }

    ###  Write the file back to disk.
    &flush_file_lines();

    ###  Re-read the portfwd config now.
    &firewallPortFwCtl('restart');
  }


  ###  Go back to the portfw listing.
  &redirect("list_portfw.cgi");
