#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001-2003, Guardian Digital Inc.
 | $Id: edit_config.cgi,v 1.8 2003/03/05 15:34:14 rwm Exp $
 |
 | Ryan W. Maple <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "firewall-lib.pl";


  ###  Define local variables.
  my (%GCONFIG);
  my ($trusted_HELP, $untrusted_HELP, $load_modules_HELP);
  my ($trusted_SELECT, $untrusted_SELECT);
  my ($STATUS, $TOGGLE, $TOGGLE_LINK);

  ###  Setup local variables.
  %GCONFIG           =  &firewallReadConfig();
  $trusted_HELP      =  &hlink("Trusted Interface", "firewall_trusted");
  $trusted_SELECT    =  &firewallBuildIfaceSelect('TRUSTED_IF', $GCONFIG{'TRUSTED_IF'}, 1, 1);
  $untrusted_HELP    =  &hlink("Untrusted Interface", "firewall_untrusted");
  $untrusted_SELECT  =  &firewallBuildIfaceSelect('UNTRUSTED_IF', $GCONFIG{'UNTRUSTED_IF'}, 1, 1);

  $load_modules_HELP =  &hlink("Load Modules at Boot", "firewall_load_modules");

    ###  Find out if the firewall is on, and offer options to control it.
    if (&firewallFirewallIsActive() eq "on") {
      $STATUS       =  "<FONT COLOR=\"GREEN\"><B>Enabled</B></FONT>\n";
      $TOGGLE       =  "Disable";
      $TOGGLE_LINK  =  "<A HREF=\"do_firewall_control.cgi?disable=1\">";
    }
    else {
      $STATUS       =  "<FONT COLOR=\"RED\"><B>Disabled</B></FONT>\n";
      $TOGGLE       =  "Enable";
      $TOGGLE_LINK  =  "<A HREF=\"do_firewall_control.cgi?enable=1\">";
    }


  ###  Print the usual header.
  &header("Firewall Setup :: General Configuration", 0);

  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <FORM ACTION="do_edit_config.cgi" METHOD="POST">
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>Firewall Setup</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Below you can change general configuration options.  Click on the help
      links for more help on a specific option.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

EOF

### Removed 12/02/02 - Nick
##
##      <TR $tb>
##        <TD COLSPAN="2"><DIV CLASS="thead"><B>Firewall Modules</B></DIV></TD>
##      </TR>
##
##      <TR $cb>
##        <TD COLSPAN="2"><DIV CLASS="nbody">
##          If this is set to "Enabled" several IP masqerading modules will be
##          loaded at system startup, allowing for the masquerading of protocols
##          such as FTP, IRC, and PPTP.  For a full list of such protocol please
##          click on the help link below.
##
##          <P><TABLE BORDER="0">
##          <TR>
##            <TD><DIV CLASS="nbody"><B>$load_modules_HELP</B>:</DIV></TD>
##            <TD><DIV CLASS="nbody">
##              <SELECT NAME="LOAD_MODULES">
##EOF
##
##
##  ###  Order our "load modules" SELECT.
##  if ($GCONFIG{'LOAD_MODULES'} eq "yes") {
##    print "              <OPTION VALUE=\"NULL\">Please Select</OPTION>\n";
##    print "              <OPTION VALUE=\"yes\" SELECTED>Enabled</OPTION>\n";
##    print "              <OPTION VALUE=\"no\">Disabled</OPTION>\n";
##  }
##  elsif ($GCONFIG{'LOAD_MODULES'} eq "no") {
##    print "              <OPTION VALUE=\"NULL\">Please Select</OPTION>\n";
##    print "              <OPTION VALUE=\"yes\">Enabled</OPTION>\n";
##    print "              <OPTION VALUE=\"no\" SELECTED>Disabled</OPTION>\n";
##  }
##  else {
##    print "              <OPTION VALUE=\"NULL\" SELECTED>Please Select</OPTION>\n";
##    print "              <OPTION VALUE=\"yes\">Enabled</OPTION>\n";
##    print "              <OPTION VALUE=\"no\">Disabled</OPTION>\n";
##  }
##
##
##  ###  More HTML.
##  print <<EOF;
##              </SELECT>
##             </DIV></TD>
##          </TR>
##          </TABLE>
##        </TD>
##      </TR>

    print <<EOF;
  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">

      <TR $tb>
        <TD COLSPAN="2"><DIV CLASS="thead"><B>Firewall Status</B></DIV></TD>
      </TR>

      <TR $cb>
        <TD COLSPAN="2"><DIV CLASS="nbody">
          The firewall is currently $STATUS.  Please note that this does not
          mean that you actually have firewall rules in place.  This only notes
          that firewalling is configured to be turned on/off at this point in
          time.

          <P>To see what rules you currently have in place, type
          "/etc/init.d/iptables status", as root, from a shell prompt.

          <P><TABLE BORDER="0">
          <TR>
            <TD><DIV CLASS="nbody"><B>$TOGGLE Firewall</B>:</DIV></TD>
            <TD><DIV CLASS="nbody"><B>$TOGGLE_LINK Click here</A></B></DIV></TD>
          </TR>
          <TR>
            <TD><DIV CLASS="nbody"><B>Restart Firewall</B>:</DIV></TD>
            <TD><DIV CLASS="nbody"><B><A HREF="do_firewall_control.cgi?restart=1">Click here</A></B></DIV></TD>
          </TR>
          </TABLE>
        </DIV></TD>
      </TR>

      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>
      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>

EOF

  ###  Only display firewall info if we have more then one interface.
  if (&firewallNumInterfaces() > 1) {
    print <<EOF;
      <TR $tb>
        <TD><DIV CLASS="thead"><B>Configuration Option</B></DIV></TD>
        <TD><DIV CLASS="thead"><B>Setting</B></DIV></TD>
      </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>$trusted_HELP</B></DIV></TD>
        <TD><DIV CLASS="toolfont">
$trusted_SELECT
        </DIV></TD>
      </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>$untrusted_HELP</B></DIV></TD>
        <TD><DIV CLASS="toolfont">
$untrusted_SELECT
        </DIV></TD>
      </TR>
EOF
  }

  ###  We're on a one-interface machine, so only ask for a subset of the info.
  else {
    my ($iface);

    ###  We only have one, so get it's name.
    foreach my $i (&firewallGetInterfaces()) {
      next if ($i->{'virtual'}); $iface = $i->{'iface'}
    }

    ###  Now print the HTML.
    print <<EOF;
      <TR $tb>
        <TD COLSPAN="2"><DIV CLASS="thead"><B>Single-Interface Machine</B></DIV></TD>
      </TR>

      <TR>
        <TD COLSPAN="2"><DIV CLASS="nbody">
          Your machine only has one interface active, so host-only firewalling
          will be set up on this machine. 
        </DIV></TD>
      </TR>


          <INPUT TYPE="HIDDEN" NAME="single_iface" VALUE="1">
          <INPUT TYPE="HIDDEN" NAME="UNTRUSTED_IF" VALUE="$iface">
        </DIV></TD>
      </TR>
EOF

  }


  ###  More HTML.
  print <<EOF;
      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR>
        <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS="nbody">
          <INPUT TYPE="SUBMIT" VALUE="Save Configuration">
        </DIV></TD>
      </TR>
      </TABLE>
    </TD>
  </TR>

  </TABLE>
  </FORM>
</CENTER><P>&nbsp;
EOF

  ###  Print the usual footer.
  &ryanFooter("index.cgi");

