#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001-2003, Guardian Digital Inc.
 | $Id: edit_portfw.cgi,v 1.5 2003/02/25 19:48:05 rwm Exp $
 |
 | Ryan W. Maple <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines and populate %in.
  require "firewall-lib.pl";
  &ReadParse();


  ###  Define local variables.
  my (%GCONFIG, $portfw_HEADER, $portfw_TEXT, $portfw_SUBMIT, $CURRENT);
  my ($proto_HELP, $port_HELP, $laddr_HELP, $raddr_HELP);
  my ($proto_SELECT);

  ###  Setup local variables.
  %GCONFIG     =  &firewallReadConfig();
  $proto_HELP  =  &hlink("Protocol", "firewall_proto");
  $port_HELP   =  &hlink("Port", "firewall_port");
  $laddr_HELP  =  &hlink("Local Address", "firewall_laddr");
  $raddr_HELP  =  &hlink("Remote Address", "firewall_raddr");

  ###  Setup some specific variables for creation/edition.
  if ($in{'new'}) {
    $CURRENT        =  undef;
    $portfw_HEADER  =  "Define a New";
    $portfw_TEXT    =  "Below you can setup a new port forwarding rule.";
    $portfw_SUBMIT  =<<EOF;
      <TABLE BORDER="0" WIDTH="100%" CELLPADDING="0" CELLSPACING="0">
      <TR>
        <TD ALIGN="RIGHT"><DIV CLASS="nbody">
          <INPUT TYPE=\"SUBMIT\" NAME="create" VALUE="Define Rule">
        </DIV></TD>
      </TR>
      </TABLE>
EOF
  }
  else {
    $portfw_HEADER  =  "Edit a";
    $portfw_TEXT    =  "Below you can edit or delete an existing port ";
    $portfw_TEXT   .=  "forwarding rule.";
    $portfw_SUBMIT  =<<EOF;
      <TABLE BORDER="0" WIDTH="100%" CELLPADDING="0" CELLSPACING="0">
      <TR>
        <TD ALIGN="LEFT"><DIV CLASS="nbody">
          <INPUT TYPE=\"SUBMIT\" NAME="delete" VALUE="Delete Rule">
        </DIV></TD>
        <TD ALIGN="RIGHT"><DIV CLASS="nbody">
          <INPUT TYPE=\"SUBMIT\" NAME="save" VALUE="Save Rule">
        </DIV></TD>
      </TR>
      </TABLE>
EOF

    ###  Setup $CURRENT.
    foreach my $p (&firewallListPortfw()) {
      if ($p->{'lineno'} eq $in{'lineno'}) { $CURRENT = $p; }
    }
  }


  ###  Print the usual header.
  &header("Firewall Setup :: $portfw_HEADER Port Forwarding Rule", 0);

  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <FORM ACTION="do_edit_portfw.cgi" METHOD="POST">
  <INPUT TYPE="HIDDEN" NAME="lineno" VALUE="$CURRENT->{'lineno'}">
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>Firewall Setup</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      $portfw_TEXT
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $cb>
        <TD WIDTH="25%"><DIV CLASS="nbody"><B>$proto_HELP</B></DIV></TD>
        <TD WIDTH="25%"><DIV CLASS="toolfont">
          <SELECT NAME="proto">
EOF


  ###  Display all the protocols, selecting the "current" one.
  foreach my $p (@PORTFW_PROTOCOLS) {
    print "            <OPTION VALUE=\"$p\" ";
    print "SELECTED" if ($CURRENT->{'proto'} eq $p);
    print ">$p</OPTION>\n"; 
  }


  ###  More HTML.
  print <<EOF;
          </SELECT>
        </DIV></TD>

        <TD WIDTH="25%"><DIV CLASS="nbody"><B>$port_HELP</B></DIV></TD>
        <TD WIDTH="25%"><DIV CLASS="toolfont">
          <SELECT NAME="port">
            <OPTION VALUE="undef">Select a Port</OPTION>
EOF


  ###  Display all the ports, selecting the "current" one.
  foreach my $p (sort {$a <=> $b} keys %PORTFW_PORTS) {
    print "            <OPTION VALUE=\"$p\" ";
    print "SELECTED" if (($CURRENT->{'lport'} eq $p) &&
                         ($CURRENT->{'rport'} eq $p));
    print ">$PORTFW_PORTS{$p}</OPTION>\n"; 
  }



  ###  More HTML.
  print <<EOF;
          </SELECT>
        </DIV></TD>

      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$laddr_HELP </B></DIV></TD>
        <TD><DIV CLASS="toolfont">
          <SELECT NAME="laddr">
            <OPTION VALUE="undef">Select an Address</OPTION>
EOF


  ###  Display all the untrusted IP's, selecting the "current" one.
  foreach my $i (&firewallGetInterfaces) {
    next if ($i->{'iface'} !~ m/^$GCONFIG{'UNTRUSTED_IF'}:*/);

    print "            <OPTION VALUE=\"$i->{'address'}\" ";
    print "SELECTED" if ($CURRENT->{'laddr'} eq $i->{'address'});
    print ">$i->{'address'} ($i->{'iface'})</OPTION>\n"; 
  }


  ### More HTML.
  print <<EOF;
          </SELECT>
        </DIV></TD>

        <TD><DIV CLASS="nbody"><B>$raddr_HELP </B></DIV></TD>
        <TD>
          <INPUT TYPE="TEXT" NAME="raddr" SIZE="15" MAXLENGTH="15" VALUE="$CURRENT->{'raddr'}">
        </TD>

      </TR>

      <TR $cb> <TD COLSPAN="4"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD COLSPAN="4">
$portfw_SUBMIT
        </TD>
      </TR>
      </TABLE>
    </TD>
  </TR>

  </TABLE>
  </FORM>
</CENTER><P>&nbsp;
EOF


  ###  Print the usual footer.
  &ryanFooter("list_portfw.cgi");

