#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001-2003, Guardian Digital Inc.
 | $Id: list_portfw.cgi,v 1.4 2003/02/25 19:48:05 rwm Exp $
 |
 | Ryan W. Maple <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "firewall-lib.pl";


  ###  Print the usual header.
  &header("Firewall Setup :: Configure Port Forwarding", 0);

  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>Firewall Setup</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Below is a listing of the rules currently installed.  You can create,
      edit, or delete rules using the links below.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $tb>
        <TD><DIV CLASS="thead"><B>Protocol</B></DIV></TD>
        <TD><DIV CLASS="thead"><B>Local Host / Port</B></DIV></TD>
        <TD COLSPAN="2"><DIV CLASS="thead"><B>Remost Host / Port</B></DIV></TD>
      </TR>

EOF


  ###  Iterate through and display each rule.
  my ($PRINTED); $PRINTED = 0;
  foreach my $p (&firewallListPortfw()) {
    $PRINTED++;

    $L_port = getservbyport($p->{'lport'}, $p->{'proto'});
    $L_port = $p->{'lport'} if (! $L_port);

    $R_port = getservbyport($p->{'rport'}, $p->{'proto'});
    $R_port = $p->{'rport'} if (! $R_port);

    print <<EOF;
      <TR $cb>
        <TD><DIV CLASS="nbody"> $p->{'proto'} </DIV></TD>
        <TD><DIV CLASS="nbody"> $p->{'laddr'} ($L_port) </DIV></TD>
        <TD><DIV CLASS="nbody"> $p->{'raddr'} ($R_port) </DIV></TD>
        <TD><DIV CLASS="nbody"><B>
          <A HREF="edit_portfw.cgi?lineno=$p->{'lineno'}">[ Edit ]</A>
        </B></DIV></TD>
      </TR>

EOF
  }

  ###  We have no rules, so print something telling them so.
  if (! $PRINTED) {
    print <<EOF;
      <TR $cb>
        <TD COLSPAN="4"><DIV CLASS="nbody"><B>
          There are currently no rules defined.
        <B></DIV></TD>
      </TR>

EOF
  }


  ###  More HTML.
  print <<EOF;

      <TR $cb> <TD COLSPAN="4"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD COLSPAN="4" ALIGN="RIGHT"><DIV CLASS="nbody"><B>
          <A HREF="edit_portfw.cgi?new=1">[ Define New Rule ]</A>
        </B></DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN="4"> &nbsp; </TD> </TR>
      </TABLE>
    </TD>
  </TR>

  </TABLE>
  </FORM>
</CENTER><P>&nbsp;
EOF


  ###  Print the usual footer.
  &ryanFooter("index.cgi");

